/***************************************************************/
/*                     decision.c                              */
/*　판단 트리 구성을 지원하는 프로그램　　                     */
/*　　 입력은 표준입력에서 주고 출력은 표준출력으로 출력합니다 */
/* 사용방법                                                    */
/*       $./decision < (입력파일명）> (출력파일명)             */
/*　입력파일에는 속성과 카테고리를 0/1로 기술합니다            */
/*　출력파일에는 분류결과를 보여줍니다                         */
/***************************************************************/

/* 헤더 파일 포함 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* 기호 상수 정의 */
#define TEXTLENGTH 256 /* 텍스트의 최대길이 */
#define DATANO 256   /* 학습 데이터 세트의 최대 개수 */
#define ATTNO 4 /* 속성값의 개수 */
#define YES 1   /*yes에 대응하는 정수값 */
#define NO 0    /*no에 대응하는 정수값 */

/* 함수의 프로토타입 선언 */
int readdata(int dataset[DATANO][ATTNO+1]) ;
                     /* 학습 데이터 읽기 */
void evalp(int dataset[DATANO][ATTNO+1],int no,int i,int yorn) ;
                /*     속성의 평가       */

/*******************/
/*    main()함수   */
/*******************/
int main(int argc,char *argv[])
{
 int no ; /* 학습 데이터 세트의 개수 */
 int i ; /* 반복의 제어문자 */
 int dataset[DATANO][ATTNO+1]={0} ;
       /* 학습 데이터 세트의 속성과 카테고리를 저장 */

 /*학습 데이터 세트 읽기*/
 no=readdata(dataset) ;

 /* 각 속성에 의한 분류 */
 for(i=0;i<ATTNO;++i){
  printf("\np%d\n",i+1) ;
  /*Yes에 대응한 학습 데이터 카운트 */
  printf("Yes ") ;
  evalp(dataset,no,i,YES) ;
  /*No에 대응한 학습 데이터 카운트 */
  printf("No  ") ;
  evalp(dataset,no,i,NO) ;
 }
 
 return 0 ;
}

/************************/
/*   readdata() 함수    */
/* 학습 데이터 읽어오기 */
/************************/
int readdata(int dataset[DATANO][ATTNO+1])
{
 int no=0 ; /* 학습 데이터 세트의 개수 */
 int att=0 ; /*학습 데이터 세트의 속성 */

 /* 데이터 입력 */
 while(scanf("%d",&dataset[no][att])!=EOF){
  ++ att ;
  if(att>ATTNO){/* 다음 데이터 */
   att=0 ;
   ++no ;
  }
 }
 return no ;
}



/************************/
/*     evalp() 함수     */
/*     속성 평가        */
/************************/
void evalp(int dataset[DATANO][ATTNO+1],int no,int i,int yorn)
{
 int j ; /* 반복의 제어문자 */
 int total,point;/* 평가값 */

 /*yorn에 대응한 학습 데이터 카운트 */
 j=0 ;
 total=point=0 ;
 while(j<no){/* 각 데이터에 대해 조사한다 */
  if(dataset[j][i]==yorn){
   ++ total ;/* 해당 항목 */
   if(dataset[j][i]==dataset[j][ATTNO])
    ++ point ;/* 분류했다 */
  }
  ++j ;
 }
 /* 결과 출력 */ 
 printf("%d/%d  %lf\n",point,total,(double)point/total) ;
}

